package org.apache.commons.lang3.event;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import org.apache.commons.lang3.event.EventUtils;
import org.apache.commons.lang3.reflect.MethodUtils;

class EventBindingInvocationHandler implements InvocationHandler {
  private final Object target;
  
  private final String methodName;
  
  private final Set<String> eventTypes;
  
  EventBindingInvocationHandler(Object target, String methodName, String[] eventTypes) {
    this.target = target;
    this.methodName = methodName;
    this.eventTypes = new HashSet<>(Arrays.asList(eventTypes));
  }
  
  public Object invoke(Object proxy, Method method, Object[] parameters) throws Throwable {
    if (this.eventTypes.isEmpty() || this.eventTypes.contains(method.getName())) {
      if (hasMatchingParametersMethod(method))
        return MethodUtils.invokeMethod(this.target, this.methodName, parameters); 
      return MethodUtils.invokeMethod(this.target, this.methodName);
    } 
    return null;
  }
  
  private boolean hasMatchingParametersMethod(Method method) {
    return (MethodUtils.getAccessibleMethod(this.target.getClass(), this.methodName, method.getParameterTypes()) != null);
  }
}
